Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.commons.collections.map
Class TransformedMap

    java.lang.Object
      |
      +--org.apache.commons.collections.map.AbstractMapDecorator
            |
            +--org.apache.commons.collections.map.AbstractInputCheckedMapDecorator
                  |
                  +--org.apache.commons.collections.map.TransformedMap

All Implemented Interfaces:
  Map, Serializable

Direct Known Subclasses:
  TransformedSortedMap

public class TransformedMap
extends org.apache.commons.collections.map.AbstractInputCheckedMapDecorator
implements Serializable

Decorates another `Map` to transform objects that are added.

The Map put methods and Map.Entry setValue method are affected by this class. Thus objects must be removed or searched for using their transformed form. For example, if the transformation converts Strings to Integers, you must use the Integer form to remove objects.

This class is Serializable from Commons Collections 3.1.

Since:
  Commons Collections 3.0
Version:
  $Revision: 1.11 $ $Date: 2004/06/07 22:14:42 $
Author:
  Stephen Colebourne
See Also:
  Serialized Form

Field Summary
`protected Transformer` | `keyTransformer` The transformer to use for the key
`protected Transformer` | `valueTransformer` The transformer to use for the value

Fields inherited from class org.apache.commons.collections.map.AbstractMapDecorator
`map`

Constructor Summary
`protected` | `TransformedMap(Map map, Transformer keyTransformer, Transformer valueTransformer)` Constructor that wraps (not copies).

Method Summary
`protected Object` | `checkSetValue(Object value)` Override to transform the value when using `setValue`.
`static Map` | `decorate(Map map, Transformer keyTransformer, Transformer valueTransformer)` Factory method to create a transforming map.
`Set` | `entrySet()`
`protected boolean` | `isSetValueChecking()` Override to only return true when there is a value transformer.
`Object` | `put(Object key, Object value)`
`void` | `putAll(Map mapToCopy)`
`protected Object` | `transformKey(Object object)` Transforms a key.
`protected Map` | `transformMap(Map map)` Transforms a map.
`protected Object` | `transformValue(Object object)` Transforms a value.

Methods inherited from class org.apache.commons.collections.map.AbstractMapDecorator
`clear, containsKey, containsValue, equals, get, getMap, hashCode, isEmpty, keySet, remove, size, toString, values`

Methods inherited from class java.lang.Object
`clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

Field Detail

### keyTransformer

    protected final Transformer keyTransformer

  The transformer to use for the key

### valueTransformer

    protected final Transformer valueTransformer

  The transformer to use for the value

Constructor Detail

### TransformedMap

    protected TransformedMap(Map map,
                             Transformer keyTransformer,
                             Transformer valueTransformer)

  Constructor that wraps (not copies).

  If there are any elements already in the collection being decorated, they are NOT transformed.

Parameters:
  `map` - the map to decorate, must not be null
  `keyTransformer` - the transformer to use for key conversion, null means no conversion
  `valueTransformer` - the transformer to use for value conversion, null means no conversion
Throws:
  `IllegalArgumentException` - if map is null

Method Detail

### decorate

    public static Map decorate(Map map,
                               Transformer keyTransformer,
                               Transformer valueTransformer)

  Factory method to create a transforming map.

  If there are any elements already in the map being decorated, they are NOT transformed.

  Parameters:
    `map` - the map to decorate, must not be null
    `keyTransformer` - the transformer to use for key conversion, null means no conversion
    `valueTransformer` - the transformer to use for value conversion, null means no conversion
  Throws:
    `IllegalArgumentException` - if map is null

### transformKey

    protected Object transformKey(Object object)

  Transforms a key.

  The transformer itself may throw an exception if necessary.

  Parameters:
    `object` - the object to transform
  Throws:
    `the` - transformed object

### transformValue

    protected Object transformValue(Object object)

  Transforms a value.

  The transformer itself may throw an exception if necessary.

  Parameters:
    `object` - the object to transform
  Throws:
    `the` - transformed object

### transformMap

    protected Map transformMap(Map map)

  Transforms a map.

  The transformer itself may throw an exception if necessary.

  Parameters:
    `map` - the map to transform
  Throws:
    `the` - transformed object

### checkSetValue

    protected Object checkSetValue(Object value)

  Override to transform the value when using `setValue`.

  Specified by:
    `checkSetValue` in class `org.apache.commons.collections.map.AbstractInputCheckedMapDecorator`
  Parameters:
    `value` - the value to transform
  Returns:
    the transformed value
  Since:
    Commons Collections 3.1

### isSetValueChecking

    protected boolean isSetValueChecking()

  Override to only return true when there is a value transformer.

  Overrides:
    `isSetValueChecking` in class `org.apache.commons.collections.map.AbstractInputCheckedMapDecorator`
  Returns:
    true if a value transformer is in use
  Since:
    Commons Collections 3.1

### put

    public Object put(Object key,
                      Object value)

  Specified by:
    `put` in interface `Map`
  Overrides:
    `put` in class `AbstractMapDecorator`

### putAll

    public void putAll(Map mapToCopy)

  Specified by:
    `putAll` in interface `Map`
  Overrides:
    `putAll` in class `AbstractMapDecorator`

### entrySet

    public Set entrySet()

  Specified by:
    `entrySet` in interface `Map`
  Overrides:
    `entrySet` in class `AbstractMapDecorator`

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2001-2004 Apache Software Foundation. All Rights Reserved.